unit f_setint;

interface

uses
  mksetint,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  Tfsetint = class(TForm)
    b_assign_ab: TButton;
    b_assign_ba: TButton;
    b_difference: TButton;
    b_empty_a: TButton;
    b_empty_b: TButton;
    b_exclude_a: TButton;
    b_exclude_b: TButton;
    b_include_a: TButton;
    b_include_b: TButton;
    b_intersection: TButton;
    b_invert_a: TButton;
    b_invert_b: TButton;
    b_load_a: TButton;
    b_load_b: TButton;
    b_save_a: TButton;
    b_save_b: TButton;
    b_undo_a: TButton;
    b_union: TButton;
    bevel_a: TBevel;
    bevel_b: TBevel;
    bevel_c: TBevel;
    d_open: TOpenDialog;
    d_save: TSaveDialog;
    l_empty_a: TLabel;
    l_empty_b: TLabel;
    l_equality: TLabel;
    l_subset: TLabel;
    l_superset: TLabel;
    lb_set_a: TListBox;
    lb_set_b: TListBox;
    lemail: TLabel;
    llemail: TLabel;
    llweb: TLabel;
    ls_empty_a: TLabel;
    ls_empty_b: TLabel;
    ls_equality: TLabel;
    ls_subset: TLabel;
    ls_superset: TLabel;
    lweb: TLabel;
    st_set_a: TStaticText;
    st_set_b: TStaticText;
    procedure b_assign_abClick(Sender: TObject);
    procedure b_assign_baClick(Sender: TObject);
    procedure b_differenceClick(Sender: TObject);
    procedure b_empty_aClick(Sender: TObject);
    procedure b_empty_bClick(Sender: TObject);
    procedure b_exclude_aClick(Sender: TObject);
    procedure b_exclude_bClick(Sender: TObject);
    procedure b_include_aClick(Sender: TObject);
    procedure b_include_bClick(Sender: TObject);
    procedure b_intersectionClick(Sender: TObject);
    procedure b_invert_aClick(Sender: TObject);
    procedure b_invert_bClick(Sender: TObject);
    procedure b_load_aClick(Sender: TObject);
    procedure b_load_bClick(Sender: TObject);
    procedure b_save_aClick(Sender: TObject);
    procedure b_save_bClick(Sender: TObject);
    procedure b_undo_aClick(Sender: TObject);
    procedure b_unionClick(Sender: TObject);
    procedure lemailClick(Sender: TObject);
    procedure lwebClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    set_a:tsetofinteger;    // mnozina A
    set_b:tsetofinteger;    // mnozina B
    undo1:tarrayofinteger;  // undo buffer 1
    undo2:tarrayofinteger;  // undo buffer 2
  public
    { Public declarations }
    procedure change;
  end;

var
  fsetint: Tfsetint;

implementation

{$R *.dfm}

uses
  shellapi;

resourcestring
  _include='Include';
  _invert='Invert';
  _enterinteger='Enter integer:';

// zmena stavu v mnozine A nebo B  
procedure Tfsetint.change;

procedure load(lb:tlistbox;st:tstatictext;setint:tsetofinteger;const s:string);
var
  i,c:integer;
  x:string[1];
  res:boolean;
begin
  lb.clear;
  with setint do begin
    res:=findfirst(i);
    while res do begin
      lb.items.add(inttostr(i));
      res:=findnext(i);
    end;
    c:=count;
  end;
  if c=1 then x:='' else x:='s';
  st.caption:=format('Set %s  -  %d item%s',[s,c,x]);
end;

begin
  load(lb_set_a,st_set_a,set_a,'A');
  load(lb_set_b,st_set_b,set_b,'B');
  ls_subset.caption:=booltostr(set_a.subset(set_b),true);
  ls_superset.caption:=booltostr(set_a.superset(set_b),true);
  ls_equality.caption:=booltostr(set_a.equality(set_b),true);
  ls_empty_a.caption:=booltostr(set_a.isempty,true);
  ls_empty_b.caption:=booltostr(set_b.isempty,true);
  undo1:=undo2;
  undo2:=set_a.exportasarray;
end;

// vyprazdnit mnozinu A
procedure Tfsetint.b_empty_aClick(Sender: TObject);
begin
  set_a.clear;
  change;
end;

// vyprazdnit mnozinu B
procedure Tfsetint.b_empty_bClick(Sender: TObject);
begin
  set_b.clear;
  change;
end;

// vlozit prvek do mnoziny A
procedure Tfsetint.b_include_aClick(Sender: TObject);
var
  s:string;
begin
  if inputquery(_include,_enterinteger,s) then try
    set_a.include(strtoint(s));
    change;
  except
  end;
end;

// vlozit prvek do mnoziny B
procedure Tfsetint.b_include_bClick(Sender: TObject);
var
  s:string;
begin
  if inputquery(_include,_enterinteger,s) then try
    set_b.include(strtoint(s));
    change;
  except
  end;
end;

// odstranit prvek z mnoziny A
procedure Tfsetint.b_exclude_aClick(Sender: TObject);
begin
  with lb_set_a do if itemindex>=0 then begin
    set_a.exclude(strtoint(items[itemindex]));
    change;
  end;
end;

// odstranit prvek z mnoziny B
procedure Tfsetint.b_exclude_bClick(Sender: TObject);
begin
  with lb_set_b do if itemindex>=0 then begin
    set_b.exclude(strtoint(items[itemindex]));
    change;
  end;
end;

// invertovat prvek v mnozine A
procedure Tfsetint.b_invert_aClick(Sender: TObject);
var
  s:string;
begin
  if inputquery(_invert,_enterinteger,s) then try
    set_a.invert(strtoint(s));
    change;
  except
  end;
end;

// invertovat prvek v mnozine B
procedure Tfsetint.b_invert_bClick(Sender: TObject);
var
  s:string;
begin
  if inputquery(_invert,_enterinteger,s) then try
    set_b.invert(strtoint(s));
    change;
  except
  end;
end;

// nacist mnozinu A ze souboru
procedure Tfsetint.b_load_aClick(Sender: TObject);
begin
  if d_open.execute then begin
    set_a.loadfromfile(d_open.filename);
    change;
  end;
end;

// nacist mnozinu B ze souboru
procedure Tfsetint.b_load_bClick(Sender: TObject);
begin
  if d_open.execute then begin
    set_b.loadfromfile(d_open.filename);
    change;
  end;
end;

// ulozit mnozinu A do souboru
procedure Tfsetint.b_save_aClick(Sender: TObject);
begin
  if d_save.execute then set_a.savetofile(d_save.filename);
end;

// ulozit mnozinu B do souboru
procedure Tfsetint.b_save_bClick(Sender: TObject);
begin
  if d_save.execute then set_b.savetofile(d_save.filename);
end;

// obnovit predposledni stav mnoziny A
procedure Tfsetint.b_undo_aClick(Sender: TObject);
begin
  set_a.clear;
  set_a.include(undo1);
  change;
end;

// zkopirovat obsah mnoziny A do mnoziny B
procedure Tfsetint.b_assign_abClick(Sender: TObject);
begin
  set_b.assign(set_a);
  change;
end;

// zkopirovat obsah mnoziny B do mnoziny A
procedure Tfsetint.b_assign_baClick(Sender: TObject);
begin
  set_a.assign(set_b);
  change;
end;

// prunik mnozin A a B
procedure Tfsetint.b_intersectionClick(Sender: TObject);
begin
  set_a.intersection(set_b);
  change;
end;

// sjednoceni mnozin A a B
procedure Tfsetint.b_unionClick(Sender: TObject);
begin
  set_a.union(set_b);
  change;
end;

// rozdil mnozin A a B
procedure Tfsetint.b_differenceClick(Sender: TObject);
begin
  set_a.difference(set_b);
  change;
end;

// web
procedure Tfsetint.lwebClick(Sender: TObject);
begin
  shellexecute(0,'open',pchar(lweb.caption),'','',sw_shownormal);
end;

// e-mail
procedure Tfsetint.lemailClick(Sender: TObject);
begin
  shellexecute(0,'open',pchar('mailto:'+lemail.caption),'','',sw_shownormal);
end;

// vytvoreni hlavniho formulare
procedure Tfsetint.FormCreate(Sender: TObject);
begin
  set_a:=tsetofinteger.create;
  set_b:=tsetofinteger.create;
  undo1:=nil;
  undo2:=nil;
  change;
end;

// uvolneni hlavniho formulare
procedure Tfsetint.FormDestroy(Sender: TObject);
begin
  set_a.free;
  set_b.free;
  undo1:=nil;
  undo2:=nil;
end;

end.
